if (MCE!=undefined && MCE.applicationName=='Converter' && !MCE.finishedLoading) {
MCE.currency.iface={
	cacheExpiration:24*3600000, // on a daily basis
	pO:false,

	// is the cache expired for this particular conversion rate?
	cacheExpired:function(from,to)
	{
		var d=new Date();
		var pref='date_'+from+'_'+to;
		if (this.pO.getPrefType(pref)==this.pO.PREF_INVALID) {
                        // not available, ergo "expired"
                        return true;
                }
		var expirationDate=Number(this.pO.getCharPref(pref))+this.cacheExpiration;
		var currentDate=d.getTime();
		return (currentDate>expirationDate);
	},

	// get this rate from cache, if available (no expiration test)
	retrieveCache:function(from,to)
	{
		var pref='rate_'+from+'_'+to;
		if (this.pO.getPrefType(pref)==this.pO.PREF_INVALID) {
			// not available
			return false;
		}
		return this.pO.getCharPref(pref);
	},

	// try getting this rate from cache, if available and not expired
	getCache:function(from,to)
	{
		if (this.cacheExpired(from,to)) {
			return false;
		}
		return this.retrieveCache(from,to);
	},

	saveCache:function(from,to,rate)
	{
		var d=new Date();
		this.pO.setCharPref('date_'+from+'_'+to,d.getTime());
		this.pO.setCharPref('rate_'+from+'_'+to,rate);
		return true;
	},

        init:function()
        {
                var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefService);
                prefs = prefs.getBranch("extensions.converter.currency_data.");
                this.pO=prefs;
        }
}

MCE.currency.iface.init();

}
